    <#if front_block??>
    ${front_block}
    <#else>
    /**
     * 界面行为
     *
     * @param {any[]} arg
     * @param {*} [params]
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${view.name}')}
     */
    public ${item.getFullCodeName()}(arg: any[], params?: any, $event?: any): any {
         return new Promise((resolve, reject) => {
            <#if item.getFrontProcessType() == 'OPENHTMLPAGE'>
            const data: any = arg[0];
            const url = `${item.getHtmlPageUrl()}`;
            window.open(url, '_blank');
            resolve();
            </#if>
            <#if item.getFrontProcessType() == 'TOP'>
            let refview = { 
                <#if item.getFrontPSAppView(view)??>
                <#assign frontview = item.getFrontPSAppView(view)>
                path: '${frontview.getPSAppModule().codeName?lower_case}_${frontview.codeName?lower_case}'<#if frontview.isRedirectView()>, redirectview: true, backendurl: '${frontview.getPSAppModule().codeName}/${frontview.codeName}.do'</#if>
                </#if>
            };
            const data: any = {};
            if (arg.length > 0) {
                Object.assign(data, {srfkey: arg[0].srfkey})
            }
            this.$router.push({ name: refview.path,query: {srfkey:data.srfkey}});
            resolve();
            </#if>
            <#if item.getFrontProcessType() == 'WIZARD'>
            
            let refviews = { 
                <#if item.getFrontPSAppView(view)??>
                <#assign frontview = item.getFrontPSAppView(view)>
                viewname: 'view-${srfclassname('${frontview.getCodeName()}')?lower_case}'<#if frontview.isRedirectView()>, redirectview: true, backendurl: '${frontview.getPSAppModule().codeName}/${frontview.codeName}.do'</#if>
                </#if>
            };
            const data: any = {};
            if (arg.length > 0) {
                Object.assign(data, { srfkey: arg[0].srfkey })
            }
            const view = { componentName: refviews.viewname,viewdata:JSON.stringify(data)};
            let modalContainer: Subject<any>;
            modalContainer=this.$modal(view).show();
            modalContainer.subscribe((result:any) => {
                console.log(result)
                resolve(result);
            });
            </#if>
        });
        
    }
    </#if>
    