    <#if item.getPSViewLogic?? && item.getPSViewLogic()??>
    <#assign viewlogic = item.getPSViewLogic()/>
    /**
     * 打开编辑数据视图
     *
     * @param {*} [params={}]
     * @memberof ${srfclassname('${view.name}')}
     */
    public ${item.name}(params: any = {}) {
        <#if viewlogic.getOpenDataPSAppView()??>
        <#assign dataview = viewlogic.getOpenDataPSAppView()/>
        <#if dataview.isRedirectView()>
          <#if dataview.getViewType()?? && dataview.getViewType()=='DEMOBREDIRECTVIEW'>
        const url: string = '${app.getPKGCodeName()?lower_case}/ibizutil/worklist/redirectview/getmodel';
        const get: Promise<any> = this.$http.get(url, { srfkey: params.taskid });
          <#else>
        const url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${dataview.getPSDEViewCodeName()?lower_case}/getmodel';
        const get: Promise<any> = this.$http.get(url, { srfkey: params.srfkey });
          </#if>
        get.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$notify({ type: 'danger', message: '错误,' + response.data.info });
            }
            const data = response.data;
            if (Object.keys(data).length === 0) {
                return;
            }
            if (Object.is(data.openmode, 'POPUPMODAL')) {
                if (data.viewname) {
                    const viewname = 'view-'+data.viewname.toLowerCase();
                    let modalSubject = this.$modal({
                        componentName: viewname,
                        viewdata:JSON.stringify({ srfkey: params.srfkey })
                    }).show();
                    modalSubject.subscribe((res: any) => {
                        if (res) {
                            return Promise.resolve(res);
                        }
                    });
                } else {
                    console.log("选择视图未配置");
                }
                } else {
                const tatget = data.viewmodule.toLowerCase() + '_' + data.viewname.toLowerCase();
                <#if dataview.getViewType()?? && dataview.getViewType()=='DEMOBREDIRECTVIEW'>
                this.$router.push({ name: tatget, query: {srfkey:params.srfkey,taskid:params.taskid} });
                <#else>
                this.$router.push({ name: tatget, query: {srfkey:params.srfkey} });
                </#if>
            }      
        }).catch((error: any) => {
            this.$notify({ type: 'danger', message: '错误,' + error.info });
        });
        <#elseif dataview.getOpenMode() =='INDEXVIEWTAB' || dataview.getOpenMode() == ''>
        this.$router.push({ name: '${dataview.getPSAppModule().getCodeName()?lower_case}_${dataview.getCodeName()?lower_case}', query: {srfkey:params.srfkey}});
        <#elseif dataview.getOpenMode() =='POPUP'>
        console.log('POPUP非模式弹出，暂时不实现');
        <#elseif dataview.getOpenMode() =='POPUPMODAL'>
        let modalSubject = this.$modal({
            componentName: 'view-${dataview.getCodeName()?lower_case}',
            viewdata:JSON.stringify({ srfkey: params.srfkey })
        }).show();
        modalSubject.subscribe((res: any) => {
            if (res) {
                const _this: any = this;
                if (_this.refresh && _this.refresh instanceof Function) {
                    _this.refresh(res);
                }
                if (_this.engine) {
                    _this.engine.doSysUIAction('Refresh');
                }
                return Promise.resolve(res);
            }
        });
        <#elseif dataview.getOpenMode() =='POPUPAPP'>
        console.log('POPUPAPP弹出，暂时不实现'); 
        <#elseif dataview.getOpenMode()?index_of('DRAWER') == 0>
        console.log('DRAWER模式弹出，暂时不实现'); 
        <#elseif dataview.getOpenMode() == 'POPOVER'>
        console.log('DRAWER模式弹出，暂时不实现'); 
        <#elseif dataview.getOpenMode()?index_of('USER') == 0>
        console.log('${dataview.getOpenMode()}用户自定义');
        </#if>
        </#if>
    }
    </#if>